#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "tokenizer.h"

_token tokens;

long tokenize(FILE *fp)
	{
	_token *p = &tokens;
	char szBuffer[0x1000];
	long l = 0;
	char ch = 0;
	bool bComment = false;
	long lLine = 1;

	while (!feof(fp))
		{
		fread(&szBuffer[l], 1, 1, fp);

		if (szBuffer[l] == '/')
			{
			fread(&ch, 1, 1, fp);
			if (ch == '/')
				{
				bComment = true;
				ch = 0;
				}
			else
				fseek(fp, -1, SEEK_CUR);
			}

		while (bComment && !feof(fp))
			{
			if (ch == '\n')
				{
				bComment = false;
				lLine++;
				}

			if (bComment)
				fread(&ch, 1, 1, fp);
			}

		if (isspace(szBuffer[l]))
			{
			if (szBuffer[l] == '\n')
				lLine++;

			if (strlen(szBuffer) > 1)
				{
				szBuffer[l] = NULL;
				p->psz = (char *)malloc(strlen(szBuffer) + 1);
				sprintf(p->psz, "%s", szBuffer);
				p->lLine = lLine;

				p->pNext = (_token *)malloc(sizeof(_token));
				p->pNext->pNext = NULL;
				p->pNext->pParent = p;
				p = p->pNext;
				}
			l = 0;
			szBuffer[0] = NULL;
			szBuffer[1] = NULL; //not sure if we need this here but we'll play it safe... we can test to see if we need this later
			}
		else if ((szBuffer[l] == ';') || (szBuffer[l] == ',') || (szBuffer[l] == ':') || ((l > 0) && isdigit(szBuffer[l - 1]) && (szBuffer[l] == 'h')) ||
			     (szBuffer[l] == '\''))
			{
			ch = szBuffer[l];
			szBuffer[l] = NULL;
			p->psz = (char *)malloc(strlen(szBuffer) + 1);
			sprintf(p->psz, "%s", szBuffer);
			p->lLine = lLine;

			p->pNext = (_token *)malloc(sizeof(_token));
			p->pNext->pParent = p;
			p = p->pNext;
			p->pNext = NULL;
			p->psz = (char *)malloc(2);
			sprintf(p->psz, "%c", ch);
			p->lLine = lLine;

			p->pNext = (_token *)malloc(sizeof(_token));
			p->pNext->pNext = NULL;
			p->pNext->pParent = p;
			p = p->pNext;

			szBuffer[0] = NULL;
			szBuffer[1] = NULL; //so we don't accidently read in spaces as tokens
			l = 0;
			}
		else if (szBuffer[l] != '/')
			l++;
		}

	p = p->pParent;
	free(p->pNext);
	p->pNext = NULL;

	return 0;
	}