#pragma once

#include <stdio.h>

#define	KW_STATIC_VAR				0x1
#define	KW_PIECE					0x2
#define	KW_PROC						0x3
#define	COMMA						0x4
#define	END_STMT					0x5
#define	MOVE						0x6
#define	TURN						0x7
#define	SPIN						0x8
#define	STOPSPIN					0x9
#define	SHOW						0xA
#define	HIDE						0xB
#define	CACHE						0xC
#define	DONTCACHE					0xD
#define	UNK1						0xE
#define	UNK2						0xF
#define	MOVENOW						0x10
#define	TURNNOW						0x11
#define	SHADE						0x12
#define	DONTSHADE					0x13
#define	SFX							0x14
#define	WAITFORTURN					0x15
#define	WAITFORMOVE					0x16
#define	SLEEP						0x17
#define	UNK3						0x18
#define	PUSHCONSTANT				0x19
#define	PUSHVAR						0x1A
#define	PUSHSTATIC					0x1B
#define	CREATELOCALVAR				0x1C
#define	UNK4						0x1D
#define	POPVAR						0x1E
#define	POPSTATIC					0x1F
#define	STACKFLUSH					0x20
#define	ADD							0x21
#define	SUB							0x22
#define	MUL							0x23
#define	DIV							0x24
#define	AND							0x25
#define	OR							0x26
#define	XOR							0x27
#define	NOT							0x28
#define	RAND						0x29
#define	GETUV						0x2A
#define	GET							0x2B
#define	UNK5						0x2C
#define	SHL							0x2C
#define	UNK6						0x2D
#define	SAR							0x2D
#define	SETL						0x2E
#define	SETLE						0x2F
#define	SETG						0x30
#define	SETGE						0x31
#define	CMP							0x32
#define	SETE						0x33
#define	SETNE						0x34
#define	LAND						0x35
#define	LOR							0x36
#define	LXOR						0x37
#define	NEG							0x38
#define	START						0x39
#define	CALL						0x3A
#define	UNK7						0x3B
#define	JMP							0x3C
#define	RET							0x3D
#define	JNE							0x3E
#define	JNZ							0x3E //unused
#define	SIG							0x3F
#define	MASK						0x40
#define	EXPLODE						0x41
#define	SET							0x42
#define	ATTACH						0x43
#define	DROP						0x44
#define	UNK8						0x45
#define	DDW							0x46
#define	QUOTEMARK					0x47
#define	INT							0x48
#define	FLOAT						0x49
#define	LABEL						0x4A
#define	KW_ARGS						0x4B
#define	KW_VAR						0x4C
#define NOCODE						0x4D
#define	NEWPROC						0x5D
#define	DECL_STATIC_VAR				0x5E
#define	DECL_PIECE					0x5F
#define	DECL_LOCAL_VAR				0x6F
#define HEX_INT						0x70
#define	NOP							0x71
#define LBL_JMP						0x72
#define	ANGULAR_INT					0x73
#define	LINEAR_INT					0x74
#define	ANGULAR_FLOAT				0x75
#define	LINEAR_FLOAT				0x76
#define	KW_UNRECOGNIZED				0x77
#define	COBALT_OPCODE				0x78
#define	ANGULAR_HEX_INT				0x79
#define	LINEAR_HEX_INT				0x7A
#define	EMPTY						0x7B
#define	INVOKE						0x7C
#define	DLL_LINK					0x7D
#define	PUSH_STRING					0x7E
#define	STRING_LINK					0x7F
#define OUTPUT_STRING				0x80
#define	STRING_FOR_OUTPUT_ONLY		0x81

typedef struct _token
	{
	char *psz;
	long lType;
	long lLine;
	long lMoreInfo;

	_token *pNext;
	_token *pParent;
	}_token;

long tokenize(FILE *fp);