#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include "parser.h"
#include "warningreporter.h"

extern bool	bLog;
extern long	lnWarnings;
extern char **ppszWarningText;

extern time_t	tTime;

extern bool	bWarningsAsErrors;

extern long	lnErrors;
extern long	*lpErrors;

long *lpWarningNumbers;

long addwarning(long lWarning, _token *pTok)
	{
	lnWarnings++;

	ppszWarningText = (char **)realloc(ppszWarningText, lnWarnings * sizeof(char **));
	ppszWarningText[lnWarnings - 1] = new char [32];

	lpWarningNumbers = (long *)realloc(lpWarningNumbers, lnWarnings * 4);
	lpWarningNumbers[lnWarnings - 1] = lWarning;

	sprintf(ppszWarningText[lnWarnings - 1], "Warning on line %d: 0x%02X", pTok->lLine, lWarning);

	if (bWarningsAsErrors)
		{
		lnErrors++;
		lpErrors = (long *)realloc(lpErrors, lnErrors * 4);
		lpErrors[lnErrors - 1] = WARNINGS_AS_ERRORS;
		lpErrors[lnErrors - 1] |= (pTok->lLine << 16);
		return NULL;
		}

	return 0;
	}

long reportwarnings(char *psz)
	{
	FILE *fp;

	if (bLog)
		{
		fp = fopen("warnings.txt", "a");
		if (!fp)
			{
			bLog = false;
			printf("Error opening log file \"warnings.txt\"");
			goto NoLog;
			}

		fprintf(fp, "Warnings for %s, %s\n-==--==--==--==--==--==--==--==--==--==--==--==--==--==--==--==-\n", psz, ctime(&tTime));
		}

NoLog:

	for(long i = 0; i < lnWarnings; i++)
		{
		if (bLog)
			fprintf(fp, "%s", ppszWarningText[i]);

		printf("%s", ppszWarningText[i]);

		switch (lpWarningNumbers[i])
			{
			case ADDING_STRING_ALREADY_EXISTS:
				if (bLog)
					fprintf(fp, " (%s)", "Adding duplicate string to file");
				printf(" (%s)", "Adding duplicate string to file");
				break;
			}
		}

	return 0;
	}